/*
 * Programma S
 * Test dell' IO su/da dispositivi di memorizzazione di massa, hard disk
 * e floppy disk.
 * Verificare che il sistema sia compilato correttamente per
 *  l' ambiente in uso: se si esegue su PC la variabile BOCHS almeno
 *  nel modulo io.cpp non deve essere definita (#undef BOCHS), viceversa
 *  se si sta usando l'emulatore
 *  ATTENZIONE: la scrittura su hard disk di un sistema reale puo'
 *  rendere i dati che vi sono memorizzati inconsistenti o rendere il
 *  sistema non piu' avviabile! Usare questo programma di prova con
 *  prudenza, SOLO se si ha un hard disk apposito o sull'emulatore Bochs!!
 */

#include <sys.h>
#include <lib.h>
#include <dma.h>

#define N_ATA 2

/*
 * Variabili condivise, necessarie per come viene gestito l' IO da
 *  interfaccia seriale.
 */
 
extern short hd_buffer[256*256];

EXTERN_DMA_BUFF(fd_buffer);

/*
 * Processo M
 */

#include <string.h>

void pm(int a)
{
	int c,d,p,q_i;
	unsigned char q;
	char errore;
	bool ris;
	int nb,s;

	unsigned short cilindri,settori,testine;
	int totale;

	int cmd_len, ata_len, drv_len, start_len, blk_len;
	char cmd[200], ata[200], drv[200], start[200], blk[200];
	
	// Probing degli hard disk

	
	for (int i=0;i<N_ATA;i++)
		for (int d=0;d<2;d++) {
			printf(a, "Geometria del disco %d:%d\n",i,d);
			geometria(i,d,cilindri,testine,settori,totale,errore);
			if (errore==0) {
				printf(a,"C-H-S: %d /  %d /  %d \n",cilindri,testine,settori);
				printf(a,"Totale Settori: %d\n",totale);
			}
			else
				printf(a,"Errore! disco %d:%d non presente\n",i,d);
	}
 
	printf(a, "Processo di prova accessi alla memoria di massa\n");
	 
	while(1) {
		printf(a, "\nScelte possibili:\n");
		printf(a, "A - Scrivi su hard disk\n");
		printf(a, "B - Leggi da hard disk\n");
		printf(a, "C - Scrivi su floppy\n");
		printf(a, "D - Leggi da floppy\n");
		printf(a, "Q - Esci\n");
		printf(a, "Scelta -> ");

		cmd_len = 200;
		term_read_n(a, cmd, cmd_len);

		switch(cmd[0]) {
			case 'a':
			case 'A':
			case 'b':
			case 'B':
				ata_len=200;
				printf(a,"Quale controller -> ");
				term_read_n(a,ata,ata_len);
				c=stoi(ata,ata_len,ris);
				drv_len=200;
				printf(a,"Quale drive -> ");
				term_read_n(a,drv,drv_len);
				d=stoi(drv,drv_len,ris);
				start_len=200;
				printf(a, "Blocco di partenza -> ");
				term_read_n(a,start,start_len);
				p=stoi(start,start_len,ris);
				blk_len=200;
				printf(a, "Numero di blocchi -> ");
				term_read_n(a,blk,blk_len);
				q_i=stoi(blk,blk_len,ris);
				if (q_i>256) {
					printf(a,"Troppi blocchi da trasferire, (max 256)!\n");
					continue;
				}
				q=q_i;
				if (cmd[0]=='a' || cmd[0]=='A') {
					for (int i=0;i<256*256;i++)
						hd_buffer[i]=i;
					printf(a, "Scrittura di %d blocchi sul drive %d del controllore %d a partire da %d\n",q,d,c,p);
					writehd_n(c,d,hd_buffer,p,q,errore);
				}
				else {
					for (int i=0;i<256*256;i++)
						hd_buffer[i]=0;
					nb=q;
					s=32;
					printf(a, "Lettura di %d blocchi dal drive %d del controllore %d a partire da %d\n",q,d,c,p);
					readhd_n(c,d,hd_buffer,p,q,errore);
					if (q==0) {
						printf(a, "Stampa (non completa) dei blocchi letti\n");
						for (int i=0;i<256*(nb==0?256:nb);i+=s)
							printf(a,"%d ",hd_buffer[i]);
						}
				}
				if (q!=0) {
					printf(a,"Errore nel trasferimento!\n");
					printf(a,"Codice di errore: %x\nBlocchi non trasferiti: %d\n",errore,q);
				}
				else
					printf(a,"Trasferimento completato correttamente\n");
				
				break;
			case 'c':
			case 'C':
			case 'd':
			case 'D':
				drv_len=200;
				printf(a,"Quale drive -> ");
				term_read_n(a,drv,drv_len);
				d=stoi(drv,drv_len,ris);
				start_len=200;
				printf(a, "Blocco di partenza -> ");
				term_read_n(a,start,start_len);
				p=stoi(start,start_len,ris);
				blk_len=200;
				printf(a, "Numero di blocchi -> ");
				term_read_n(a,blk,blk_len);
				q_i=stoi(blk,blk_len,ris);
				if (q_i>128) {
					printf(a,"Troppi blocchi da trasferire, (max 128)!\n");
					continue;
				}
				q=q_i;
				if (cmd[0]=='c' || cmd[0]=='C') {
					for (int i=0;i<256*128;i++)
						fd_buffer[i]=i;
					printf(a,"Scrittura di %d blocchi sul floppy %d a partire da %d\n",q,d,p);
					writefd_n(d,fd_buffer,p,q,errore);
				}
				else {
					for (int i=0;i<256*128;i++)
						fd_buffer[i]=0;
					nb=q;
					s=32;
					printf(a,"Lettura di %d blocchi dal floppy %d a partire da %d\n",q,d,p);
					readfd_n(d,fd_buffer,p,q,errore);
					if (q==0) {
						printf(a, "Stampa (non completa) dei blocchi letti\n");
						for (int i=0;i<256*nb;i+=s)
							printf(a,"%d ",fd_buffer[i]);
						}
				}
				if (q!=0) {
					printf(a,"Errore nel trasferimento!\n");
					printf(a,"Codice di errore: %x\nBlocchi non trasferiti: %d\n",errore,q);
				}
				else
					printf(a,"Trasferimento completato correttamente\n");
				
				break;
			case 'q':
			case 'Q':
				printf(a, "Fine.\n");
				goto end;
		}
	}
end:	;

	terminate_p();
}
